--
-- DoorOpenerK744R4
--
-- written by fruktor, visit: www.eifok-team.de
-- Edit by }I{EKA special for MTZ-1025

DoorOpenerK744R4 = {};

DoorOpenerK744R4.modDir = g_currentModDirectory;

function DoorOpenerK744R4.prerequisitesPresent(specializations)
    return true; 
end;

function DoorOpenerK744R4.registerEventListeners(vehicleType)	
	SpecializationUtil.registerEventListener(vehicleType, "onRegisterActionEvents", DoorOpenerK744R4)
	SpecializationUtil.registerEventListener(vehicleType, "onLoad", DoorOpenerK744R4);
	SpecializationUtil.registerEventListener(vehicleType, "onDelete", DoorOpenerK744R4)
	SpecializationUtil.registerEventListener(vehicleType, "onUpdate", DoorOpenerK744R4)
end

-- function DoorOpenerK744R4:onRegisterActionEvents(isActiveForInput)
    -- if self.isClient then
		-- local spec = self.actionEventScript;
		-- self:clearActionEventsTable(spec.actionEvents);
		-- spec.actionEventIds = {};			
		-- if self:getIsActiveForInput(true, true) then
            -- eventAdded, actionEventId = self:addActionEvent(spec.actionEvents, "LEFT_DOOR_OPENER", self, DoorOpenerK744R4.onInputAction, false, false, true, true, nil);
			-- eventAdded1, actionEventId1 = self:addActionEvent(spec.actionEvents, "KAPOT_OPENER", self, DoorOpenerK744R4.onInputAction, false, false, true, true, nil);
			-- g_inputBinding:setActionEventTextPriority(actionEventId, GS_PRIO_HIGH);
			-- g_inputBinding:setActionEventTextPriority(actionEventId1, GS_PRIO_HIGH);
			-- -- g_inputBinding.events[actionEventId].actionEventId = 1
			-- -- g_inputBinding.events[actionEventId1].actionEventId1 = 2
		-- end;
    -- end;
-- end;
-- function DoorOpenerK744R4:onRegisterActionEvents(isActiveForInput, isActiveForInputIgnoreSelection)
    -- if self.isClient then
		-- local spec = self.actionEventScript;
		-- self:clearActionEventsTable(spec.actionEvents);
		-- spec.actionEventIds = {};	
        -- if isActiveForInputIgnoreSelection then
            -- local _, actionEventId = self:addActionEvent(spec.actionEvents, InputAction.LEFT_DOOR_OPENER, self, DoorOpenerK744R4.onInputAction, false, true, false, true, nil)
            -- g_inputBinding:setActionEventTextPriority(actionEventId, GS_PRIO_NORMAL)
            -- -- Cover.updateActionText(self)
        -- end
    -- end
-- end
function DoorOpenerK744R4:onRegisterActionEvents(isActiveForInput, isActiveForInputIgnoreSelection)
	if isActiveForInputIgnoreSelection then
		if self.ActionEvents == nil then 
			self.ActionEvents = {}
		else	
			self:clearActionEventsTable( self.ActionEvents )
		end 
		for _,actionName in pairs({ "LEFT_DOOR_OPENER"} ) do
			local _, eventName = self:addActionEvent(self.ActionEvents, InputAction[actionName], self, DoorOpenerK744R4.actionEvent, true, true, false, true, nil);
			if g_inputBinding ~= nil and g_inputBinding.events ~= nil and g_inputBinding.events[eventName] ~= nil then
				if isActiveForInputIgnoreSelection then
					g_inputBinding.events[eventName].displayPriority = 1
				elseif  isActiveForInputIgnoreSelection then
					g_inputBinding.events[eventName].displayPriority = 3
				end
				g_inputBinding.events[eventName].displayIsVisible = true
			end
		end
	end
end
function DoorOpenerK744R4.actionEvent(self, actionName, inputValue, callbackState, keyStatus, arg4, arg5, arg6)
    if self.isClient then
		if keyStatus > 0 then
			if actionName == 'LEFT_DOOR_OPENER' then
			    self.leftDoorOpen = not self.leftDoorOpen
			
			end
		end
    end
end

-- function DoorOpenerK744R4.onInputAction(self, actionName, inputValue, callbackState, isAnalog)
	-- if self.isClient and not g_gui:getIsGuiVisible() and self:getIsActiveForInput(true, true) then	
		-- if actionName == "LEFT_DOOR_OPENER" then
			-- if inputValue > 0 then
				-- self.leftDoorOpen = true
			-- else
				-- self.leftDoorOpen = false
			-- end;
		-- end;	
		-- -- if actionName == "KAPOT_OPENER" then
			-- -- if inputValue > 0 then
				-- -- self.kapotOpen = true
			-- -- else
				-- -- self.kapotOpen = false
			-- -- end;
		-- -- end;
	-- end;
-- end;

function DoorOpenerK744R4:onLoad(savegame)
    -- side Leftdoors
    self.leftDoors = {}
    self.numLeftDoors = 0;
    while true do
        local key = "vehicle.K744R4OpenDoors.Doors.leftDoor("..tostring(self.numLeftDoors)..")";
        if not hasXMLProperty(self.xmlFile, key) then
            break;
        end;
        
        self.numLeftDoors = self.numLeftDoors + 1;
        local leftDoor = {}
        leftDoor.animName = getXMLString(self.xmlFile, key.."#animName");
        leftDoor.index = self.numLeftDoors;
        leftDoor.vehicle = self;
        leftDoor.triggerId = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, key.."#triggerIndex"));
        leftDoor.playerInTrigger = false;
        addTrigger(leftDoor.triggerId, "triggerCallback", leftDoor);
        
        function leftDoor:open()
            leftDoor.vehicle:playAnimation(leftDoor.animName, 1, 0, false);
        end;
        function leftDoor:close()
            leftDoor.vehicle:playAnimation(leftDoor.animName, -1, 1, false);
        end;
        
        function leftDoor:getIsClosed()
            return leftDoor.vehicle:getAnimationTime(leftDoor.animName) == 0;
        end;
        function leftDoor:getIsOpened()
            return leftDoor.vehicle:getAnimationTime(leftDoor.animName) == 1;
        end;
        
        function leftDoor:triggerCallback(triggerId, otherId, onEnter, onLeave, onStay, otherShapeId)
            if g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then
                if onEnter then
                    leftDoor.playerInTrigger = true;
                elseif onLeave then
                    leftDoor.playerInTrigger = false;
                end;
            end;
        end;
        
        self.leftDoors[leftDoor.index] = leftDoor;
        self.leftDoors[leftDoor.animName] = leftDoor;
    end;    
	self.leftDoorOpenSound = g_soundManager:loadSampleFromXML(self.xmlFile, "vehicle.K744R4OpenDoors.sounds", "leftDoorOpen", self.baseDirectory, self.components, 1, AudioGroup.VEHICLE, self.i3dMappings, self)
	self.leftDoorCloseSound = g_soundManager:loadSampleFromXML(self.xmlFile, "vehicle.K744R4OpenDoors.sounds", "leftDoorClose", self.baseDirectory, self.components, 1, AudioGroup.VEHICLE, self.i3dMappings, self)
    -- Kapot
    self.Kapot = {}
    self.numKapot = 0;
    while true do
        local key = "vehicle.K744R4OpenDoors.Doors.Kapot744("..tostring(self.numKapot)..")";
        if not hasXMLProperty(self.xmlFile, key) then
            break;
        end;
        
        self.numKapot = self.numKapot + 1;
        local Kapot744 = {}
        Kapot744.animName = getXMLString(self.xmlFile, key.."#animName");
        Kapot744.index = self.numKapot;
        Kapot744.vehicle = self;
        Kapot744.triggerId = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, key.."#triggerIndex"));
        Kapot744.playerInTrigger = false;
        addTrigger(Kapot744.triggerId, "triggerCallback", Kapot744);
        
        function Kapot744:open()
            Kapot744.vehicle:playAnimation(Kapot744.animName, 1, 0, false);
        end;
        function Kapot744:close()
            Kapot744.vehicle:playAnimation(Kapot744.animName, -1, 1, false);
        end;
        
        function Kapot744:getIsClosed()
            return Kapot744.vehicle:getAnimationTime(Kapot744.animName) == 0;
        end;
        function Kapot744:getIsOpened()
            return Kapot744.vehicle:getAnimationTime(Kapot744.animName) == 1;
        end;
        
        function Kapot744:triggerCallback(triggerId, otherId, onEnter, onLeave, onStay, otherShapeId)
            if g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then
                if onEnter then
                    Kapot744.playerInTrigger = true;
                elseif onLeave then
                    Kapot744.playerInTrigger = false;
                end;
            end;
        end;
        
        self.Kapot[Kapot744.index] = Kapot744;
        self.Kapot[Kapot744.animName] = Kapot744;
    end;     
	self.Kapot744OpenSound = g_soundManager:loadSampleFromXML(self.xmlFile, "vehicle.K744R4OpenDoors.sounds", "Kapot744Open", self.baseDirectory, self.components, 1, AudioGroup.VEHICLE, self.i3dMappings, self)
	self.Kapot744CloseSound = g_soundManager:loadSampleFromXML(self.xmlFile, "vehicle.K744R4OpenDoors.sounds", "Kapot744Close", self.baseDirectory, self.components, 1, AudioGroup.VEHICLE, self.i3dMappings, self)
end;

function DoorOpenerK744R4:onDelete()
    for a=1, table.getn(self.leftDoors) do
        removeTrigger(self.leftDoors[a].triggerId);
    end;
    g_soundManager.deleteSample(self.leftDoorOpenSound);
    g_soundManager.deleteSample(self.leftDoorCloseSound);
	
    for a=1, table.getn(self.Kapot) do
        removeTrigger(self.Kapot[a].triggerId);
    end;
    g_soundManager.deleteSample(self.Kapot744OpenSound);
    g_soundManager.deleteSample(self.Kapot744CloseSound);
end;

function DoorOpenerK744R4:onUpdate(dt, isActiveForInput, isActiveForInputIgnoreSelection, isSelected)
    -- if not (g_gui.currentGui ~= nil or g_currentMission.isPlayerFrozen) then
        -- side door control
        for a=1, self.numLeftDoors do
            local leftDoor = self.leftDoors[a];
            if leftDoor.playerInTrigger then
                if g_currentMission.player.isEntered then
                    if leftDoor:getIsClosed() then
                        g_currentMission:addHelpButtonText(g_i18n:getText("action_leftDoor"), InputBinding.LEFT_DOOR_OPENER, nil, GS_PRIO_NORMAL)
                        if self.leftDoorOpen then
                            leftDoor:open();
                            g_soundManager.playSample(self.leftDoorOpenSound, 1, 0);
                        end;
                    elseif leftDoor:getIsOpened() then
                        if (leftDoor.animName == "leftDoorK744" ) or leftDoor.animName ~= "leftDoorK744" then
                            g_currentMission:addHelpButtonText(g_i18n:getText("action_leftDoor"), InputBinding.LEFT_DOOR_OPENER, nil, GS_PRIO_NORMAL)
                            if self.leftDoorOpen then
                                leftDoor:close();
                                g_soundManager.playSample(self.leftDoorCloseSound, 1, 0);
                            end;
                        end;
                    end;
                end;
            end;
        end;
        -- Kapot
        for a=1, self.numKapot do
            local Kapot744 = self.Kapot[a];
            if Kapot744.playerInTrigger then
                if g_currentMission.player.isEntered then
                    if Kapot744:getIsClosed() then
                        g_currentMission:addHelpButtonText(g_i18n:getText("action_kapot"), InputBinding.KAPOT_OPENER, nil, GS_PRIO_NORMAL)
                        if self.kapotOpen then
                            Kapot744:open();
                            g_soundManager.playSample(self.Kapot744OpenSound, 1, 0);
                        end;
                    elseif Kapot744:getIsOpened() then
                        if (Kapot744.animName == "KapotOpen" ) or Kapot744.animName ~= "KapotOpen" then
                            g_currentMission:addHelpButtonText(g_i18n:getText("action_kapot"), InputBinding.KAPOT_OPENER, nil, GS_PRIO_NORMAL)
                            if self.kapotOpen then
                                Kapot744:close();
                                g_soundManager.playSample(self.Kapot744CloseSound, 1, 0);
                            end;
                        end;
                    end;
                end;
            end;
        end;
    -- end;
end;